#include <qwidget.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qdialog.h>
#include <qcolor.h>
#include <qfont.h>
#include <qnamespace.h>

// language file
#include "language.h"
// end language include(s)

#include "render2d.h"
#include "fixeddialog.h"

FixedDialog::FixedDialog(QWidget *parent, QString name) : 
	QDialog(parent, name, TRUE)
{
  QPushButton *ok, *cancel, *def1;
  QLabel *t1, *t2;
  setBackgroundColor(lightGray);
  setCaption(TEXT_SET_FIXED);
  t1 = new QLabel(TEXT_SET_ANGLE, this);
  t1->setGeometry(10,10,100,30);
  t1->setBackgroundColor(lightGray);
  t2 = new QLabel(TEXT_SET_LENGTH, this);
  t2->setGeometry(10,50,100,30);
  t2->setBackgroundColor(lightGray);
  tf_id = new QLineEdit(this);
  tf_id->setGeometry(120,10,200,30);
  tf_title = new QLineEdit(this);
  tf_title->setGeometry(120,50,200,30);
  ok = new QPushButton(BUTTON_OK, this);
  ok->setGeometry(10,90,100,30);
  ok->setPalette(QPalette(lightGray));
  connect(ok, SIGNAL(clicked()), SLOT(accept()) );
  cancel = new QPushButton(BUTTON_CANCEL, this);
  cancel->setGeometry(230,90,100,30);
  cancel->setPalette(QPalette(lightGray));
  connect(cancel, SIGNAL(clicked()), SLOT(reject()) );
  def1 = new QPushButton( tr("Default"), this);
  def1->setGeometry(120,90,100,30);
  def1->setPalette(QPalette(lightGray));
  connect(def1, SIGNAL(clicked()), SLOT(setDefaults()) );
}

void FixedDialog::setDefaults() {
  QString n;
  n.setNum(15);
  tf_id->setText(n);
  n.setNum(25);
  tf_title->setText(n);
}

void FixedDialog::setAngle(double t)
{
  QString n;
  n.setNum(t);

  tf_id->setText(n);
}

void FixedDialog::setLength(double t)
{
  QString n;
  n.setNum(t);

  tf_title->setText(n);
}

double FixedDialog::getAngle(void)
{
  double t;
  bool b;

  t = tf_id->text().toDouble(&b);
  if (b == true)
    return t;
  return -1.0;
}

double FixedDialog::getLength(void)
{
  double t;
  bool b;

  t = tf_title->text().toDouble(&b);
  if (b == true)
    return t;
  return -1.0;
}
