// manual.cpp - online help.

#include <qlayout.h>
#include <qimage.h>
#include <qpixmap.h>
#include <qtoolbar.h>
#include <qtoolbutton.h>
#include <qpopupmenu.h>
#include <qmenubar.h>
#include <qkeycode.h>
#include <qmultilineedit.h>
#include <qfile.h>
#include <qfiledialog.h>
#include <qstatusbar.h>
#include <qmessagebox.h>
#include <qprinter.h>
#include <qapplication.h>
#include <qaccel.h>
#include <qtextstream.h>
#include <qpainter.h>
#include <qpaintdevicemetrics.h>
#include <qscrollview.h>
#include <qwhatsthis.h>
#include <qpushbutton.h>
#include <qdialog.h>
#include <qhbox.h>
#include <qvbox.h>
#include <qtextview.h>
#include <qbrush.h>
#include <qlabel.h>
#include <qcombobox.h>

#include "application.h"
#include "defs.h"
#include "manual.h"

// Manual pages.  Rich text format.
static const char *manpages[] = {
"<center>"
"<b>Willkommen zu XDrawChem!</b><br>"
"Bryan Herger<br>"
"herger@chemistry.gatech.edu<br>"
"</center>"
"<p><b>Navigation durch das Handbuch</b>"
"<p>Am unteren Fensterrand gibt es drei Knpfe deren Bedeutung wohl selbsterklrend sein drfte... "
"Man kann auch zu einem beliebigen Hilfethema springen, indem man es in der oberen Auswahlbox auswhlt."
"<p>Tastenkombinationen werden immer wie folgt beschrieben: "
"[Ctrl+O] bedeuted, da man die Taste [Ctrl] gedrckt hlt, whrend man die Taste [O] bettigt.",

"<b>bersicht</b>"
"<p>Das Hauptfenster von XDrawChem besteht im wesentlichen aus fnf Elementen:<br>"
"<p>Menuleiste am oberen Rand<br>"
"Werkzeugleiste direkt unterhalb der Menleiste<br>"
"Werkzeugleiste frs Zeichnen auf der linken Seite<br>"
"Statusleiste am unteren Fensterrand<br>"
"Zeichenflche<br>"
"<p>Die Werkzeugleiste unterhalb der Menleiste enthlt im wesentlichen Funktionen, "
"welche auch ber die Mens 'Datei' und 'Bearbeiten' erreichbar sind."
"<p>Die Werkzeugleiste frs Zeichnen enthlt natrlich die verfgbaren Werkzeuge frs Zeichnen."
"<p>Um eine nhere Auskunft ber ein Werkzeug zu bekommen, kann man auf den "
"<img source=\"whatsthisicon\"><b>What's this?</b> "
"Knopf klicken, gefolgt von einem Klick auf den Werkzeugknopf ber den man nheres erfahren mchte."
"<p>Die Statuszeile zeigt Fehlermeldungen, Informationen und gewhnlich auch einem Tip, "
"wie man das ausgewhlte Zeichenwerkzeug benutzt."
"<p>Die folgenden Seiten beschreiben alle Knpfe (Buttons) und Menoptionen.",

"<b>Das Dateimen und dessen Werkzeugleiste</b>"
"<p><b>Neu</b> erzeugt eine ein neues XDrawChem Fenster."
"<p><img source=\"fileopenicon\"><b>Datei ffnen</b> [Ctrl+O] ffnet eine bestehende Datei. "
"Ein Dialogfenster zur Dateiauswahl erscheint. "
"Das ffnen einer Datei berschreibt den Inhalt der aktuellen Zeichenflche!<br>"
"Dateien die nicht im XDC Format vorliegen werden beim ffnen auf die jeweils eingestellte 'Feste Lnge' skaliert."
"<p><img source=\"filesaveicon\"><b>Datei speichern</b> [Ctrl+S] speichert die aktuelle Datei. "
"Falls es sich um eine neue Datei handelt, wird der Dialog 'Speichern unter...' aus dem Dateimenu geffnet."
"<p><b>Speichern unter...</b> speichert die aktuelle Zeichnung unter einem anderen Namen ab."
"<p><b>Bild exportieren</b> speichert die aktuelle Zeichnung als Bild im Format BMP, PNG oder EPS ab. "
" Hierbei wird die ganze Zeichenflche gespeichert."
"<p><b>Seiteneinstellungen...</b> ffnet ein Fenster zum Auswhlen von Papiergre und Orientierung."
"<p><img source=\"fileprinticon\"><b>Drucken</b> [Ctrl+P] Druckt die aktuelle Zeichnung. "
" Das Druckdialogfenster erscheint um diverse Einstellungen vornehmen zu knnen."
"<p><b>Schlieen</b> [Ctrl+W] schliet das aktuelle Fenster."
"<p><b>Beenden</b> [Ctrl+Q] schliet alle Fenster und beendet XDrawChem.",

"<b>Zeichnen</b>"
"<p>Die Werkzeugleiste auf der linken Seite enthlt alle verfgbaren Zeichenwerkzeuge. "
"Man whlt das Werkzeug per Mausklick aus, um auf der Zeichenflche damit zu zeichnen."
"<p><img source=\"selecttoolicon\"><b>Auswhlen</b> whlt Objekte in der Zeichenflche aus. "
" Durch Anklicken eines Objekts wird dieses ausgewhlt, durch das Ziehen bei gedrcktem Mausknopf "
"knnen ganze Bereiche ausgewhlt werden. Der ausgewhlte Bereich wird durch einen Rahmen markiert.<br>"
"Durch das Klicken mit der Maus auf ein ausgewhltes Objekt kann man dieses, bei gedrckthalten der linken Maustaste, verschieben. "
"Klickt man hierbei jedoch auf die rechte obere Ecke des Rahmens, so kann das Objekt rotiert werden. "
"Beim Klicken auf die rechte untere Ecke kann man eine Skalierung des Objekts vornehmen."
"<p><img source=\"erasetoolicon\"><b>Lschen</b> lscht einzelne Objekte. "
"Durch das Ziehen der Maus auf ein Objekt wird dieses hervorgehoben und kann dann per Klick gelscht werden."
"<p><img source=\"linetoolicon\"><b>Linie</b> zeichnet Linien (Bindungen). "
"Die Endpunkte zweier Linien werden automatisch zusammengefhrt, wenn die neue Linie nahe dem Start- oder Endpunkt "
"beginnt oder aufhrt. Das jeweilige 'Andocken' wird durch ein kleines Quadrat gekennzeichnet. "
"Doppel- und Dreifachbindungen knnen durch das 'berzeichnen' schon existierender Bindungen erstellt werden."
"<p><img source=\"dashtoolicon\"><b>gestrichelte Linie</b> zeichnet gestrichelte Linien. "
"Diese knnen auch ber schon existierende Bindungen gezeichnet werden, um den Resonanzcharakter einer Bindung darzustellen."
"<p><img source=\"uplinetoolicon\"><b>Keil</b> dient der stereochemischen Darstellung (aus der Papierebene heraus)."
"<p><img source=\"downlinetoolicon\"><b>gestrichelter Keil</b> dient ebenfalls der stereochemischen Darstellung (in die Papierebene hinein)."
"<p><img source=\"arrowtoolicon\"><b>Pfeil</b> zeichnet verschiedene Pfeile. Bei gedrckter Maustaste auf dem Pfeilknopf erscheint ein Auswahlmen. "
"Pfeile knnen nicht mit anderen Objekten zusammengefgt werden. "
"Durch anschlieendes Auswhlen knnen Pfeile auf die gewnschte Lnge skaliert werden."
"<p><img source=\"curvearrowtoolicon\"><b>gekrmmter Pfeil</b> zeichnet Pfeile mit verschiedenen Krmmungen. "
"Bei gedrckter Maustaste auf diesem Werkzeugknopf erscheint ein Auswahlmen."
"<p><img source=\"brackettoolicon\"><b>Klammern</b> zeichnet verschiedene Arten von Klammern, "
"die ber das gedrckthalten der Maus erreichbar sind. "
"Hat man die gewnschte Klammer ausgewhlt kann man sie per Linksklick und gleichzeitigem ziehen der Maus zeichnen."
"<p><img source=\"texttoolicon\"><b>Text</b> fgt Text in eine Zeichnung ein. "
"Durch Klicken auf einen End- oder Knotenpunkt knnen andere Atomsorten markiert werden.<br>"
"Die nchste Seite beschreibt das Textwerkzeug ausfhrlicher."
"<p><img source=\"ringtoolicon\"><b>Ringe</b> ist zum Einfgen von Ringen und anderen vordefinierten Moleklen. "
"Ein Einfachklick lt eine Auswahlbox mit allen vorgefertigten Moleklen erscheinen. Bei gedrckter Maustaste erscheint "
"eine Favoritenliste von  Moleklen.<br>"
"Das Hinzufgen von Moleklen zur Favoritenliste wird weiter hinten erklrt."
"<p><img source=\"symboltoolicon\"><b>diverse Symbole</b> fgt Symbole hinzu. "
"Bei gedrckter Maustaste erscheint ein Auswahlmen. "
"",

"<b>Text</b>"
"<p>ber den <img source=\"texttoolicon\"><b>Text</b> Knopf whlt man das Textwerkzeug zum Hinzufgen oder Bearbeiten von Text. "
"Man kann den Text an einer beliebigen Stelle auf der Zeichenflche einfgen. Durch den Klick "
"auf einen Linienendpunkt knnen Elemente oder funktionelle Gruppen markiert werden. "
"Durch Klicken auf schon existierenden Text, kann dieser editiert werden. "
"<p>Whrend dem Editieren kann der text wie gewohnt mit der Maus oder per Tastenkombination [Shift+Pfeiltasten] markiert werden. "
"Mit Hilfe der <img source=\"supericon\">Hoch- und <img source=\"subicon\">Tiefstellknpfe von der oberen Werkzeugleiste "
"kann man hoch- und tiefgestellte Schriftzeichen erzeugen oder entfernen. "
"Man kann den Text auch <img source=\"boldtool\"><b>fett</b>, <img source=\"italictool\"><i>kursiv</i> oder <img source=\"underlinetool\"><u>unterstrichen</u> darstellen."
"<p>Man kann auch die Schriftart und Schriftgre des zu editierenden Textes ndern, "
"wobei sich dies immer auf den gesamten zu editierenden Text bezieht."
"",

"<b>Auswhlen und Bearbeiten</b>"
"<p>Das Ausschneiden, Kopieren und Einfgen funktioniert bis jetzt leider nur zwischen Fenstern von XDrawChem. "
"Um Zeichnungen in andere Anwendungen zu importieren, kann man "
"'Bild exportieren...' benutzen um ein Bild zu erzeugen oder das Molekl als MDL Datei abspeichern. "
"<p>Zum <b>Auswhlen</b> von Objekten benutzt man den entsprechenden Knopf <img source=\"selecttoolicon\"> auf der linken Werkzeugleiste. "
"Man zieht die Maus bei gedrckter Taste um den gewnschten Bereich auszuwhlen. "
"Man kann dieses Werkzeug auch zum Ziehen und Verschieben von Punkten oder Objekten verwenden. "
"Hierzu plaziert man den Mauszeiger ber dem gewnschten Objekt, worauf sich dieser in ein Pfeilkreuz verwandelt. "
"Durch Ziehen bei gedrckter Maustaste verschiebt man das Objekt auf der Zeichenflche."
"<p>Die <b>nderung von Objekten</b> (Bindungen, Pfeile etc.) erfolgt ebenfalls durch das Werkzeug <b>Auswhlen</b>. "
"Bewegt man den Mauszeiger auf das zu ndernde Objekt, so da es hervorgehoben wird, "
"kann durch Rechtsklick eine Auswahlbox der zu ndernden Eigenschaften aufgerufen werden."
"<p>Zum <b>Rotieren und Skalieren</b> whlt man mehrere Objekte aus, so da ein Rahmen erscheint. "
"Klickt man nun auf die rechte obere Ecke des Rahmens, so kann das Objekt rotiert werden. "
"Beim Klicken auf die rechte untere Ecke kann man eine Skalierung des Objekts vornehmen. "
"<p><b>Rckgngig</b> [Ctrl+Z] macht die letzte Aktion ungeschehen. Insgesamt knnen 16 Aktionen rckgngig gemacht werden.<br>"
"<img source=\"cuticon\"><b>Ausschneiden</b> [Ctrl+X] schneidet den ausgewhlten Bereich aus.<br>"
"<img source=\"copyicon\"><b>Kopieren</b> [Ctrl+C] kopiert den ausgewhlten Bereich.<br>"
"<img source=\"pasteicon\"><b>Einfgen</b> [Ctrl+V] fgt das zuvor Ausgeschnittene oder Kopierte wieder ein.<br>"
"<b>Lschen</b> [Del] lscht den ausgewhlten Bereich.<br>"
"<b>Alles auswhlen</b> [Ctrl+A] whlt alle Objekte auf der Zeichenflche aus.<br>"
"<b>Rotieren:</b> rotiert den ausgewhlten Bereich um 90, 180, oder 270 Grad.<br>"
"<b>Spiegeln:</b> spiegelt den ausgewhlten Bereich horizontal oder vertikal."
"",

"<b>Formatierung</b>"
"<p><b>Feste Lngen und Winkel</b> kann benutzt werden um feste Linienlngen und Winkelgren zu definieren. "
"Man findet diese Option im Men 'Formatierung'. Die Lnge der Linien ist in Pixel angegeben. "
"Um skaliert zu drucken kann man zum Beispiel 50 Pixel als feste Lnge einstellen, was bei einem Druck von 100 dpi "
"(dots per inch, einem Inch entsprechen circa 2,54 cm) dann in einer Linienlnge von einem halben Inch resultiert."
"<p>Um die <b>Schriftart und Schriftgre</b> zu ndern kann man die Werkzeuge der oberen Werkzeugleiste benutzen."
"<p>Die <b>nderung der Zeichenfarbe</b> erreicht man mit dem entsprechenden Knopf der oberen Werkzeugleiste. "
"Dieser Knopf zeigt stets die aktuelle Zeichenfarbe (normalerweise schwarz) an. "
"Durch Anklicken erscheint ein neues Fenster was die Auswahl einer anderen Farbe erlaubt."
"<p>Die <b>Hintergrundfarbe</b> kann man im Men 'Formatierung' einstellen. Es erscheint ein Fenster zur Auswahl der neuen Hintergrundfarbe."
"<p>Die <b>Linienbreite</b> kann mit der oberen Werkzeugleiste festgelegt werden. Der Knopf dafr befindet sich rechts neben der Auswahl fr die Zeichenfarbe."
"<p><b>Ausrichten</b> [Ctrl+L] richtet die Positionen von zuvor ausgewhlten Moleklen und Pfeilen automatisch aus."
"",

"<b>Werkzeuge</b>"
"<p>Dieses Men beinhaltet einige recht ntzliche Funktionen:<br>"
"<b>Ausrichten</b> [Ctrl+L] ist auf der vorherigen Seite beschrieben.<br>"
"<b>Berechne empirische Formel</b> Bei der Wahl dieses Menpunkts und dem anschlieenden Klick auf ein Molekl "
"erscheint dessen empirische Formel direkt ber ihm.<br>"
"<b>Berechne Molekulargewicht</b> Funktioniert genau wie die empirische Formel. Es erscheint das Molekulargewicht unterhalb des Molekls.<br>"
"<b>Elementaranalyse</b> Durch Wahl dieses Menpunkts und gefolgtem Klick auf ein Molekl bekommt man ein Fenster "
"mit den prozentualen Anteilen von Kohlenstoff, Wasserstoff, Sauerstoff und Stickstoff der jeweiligen Spezies.<br>"
"<b>13C NMR Vorhersage</b> Durch Wahl dieses Menpunkts und gefolgtem Klick auf ein Molekl erscheint dessen berechnetes 13C NMR Spectrum.<br>"
"<b>IR Vorhersage</b> Die Wahl dieses Menpunkts und gefolgtem Klick auf ein Molekl zeigt dessen IR Aktivitt."
"",

"<b>Internetdatenbanksuche</b>"
"<p>XDrawChem kann Molekle von einer Netzwerkdatenbank aus laden. "
"Man mu dazu das Paket 'curl' installiert haben, welches man unter http://curl.haxx.se findet."
"<p>Fr die <b>Suche im Internet</b> [Ctrl+F] whlt man zunchst den entsprechenden Eintrag im Dateimen, was den Suchdialog ffnet. "
"Der Name des Servers wird entweder whrend des Kompilierens oder durch die Umgebungsvariable XDC_SERVER festgelegt. "
"Man kann nach CAS Nummern oder Summenformeln von Moleklen suchen. Whlt man 'Genaue Treffer' kann man Molekle mit genau "
"bereinstimmender Summenformel finden. Die Suche nach der CAS Nummer sollte immer ein eindeutiges Ergebnis liefern. "
"Wird nur ein Molekl gefunden wird es automatisch eingefgt, andernfalls erscheint eine Auswahlliste."
"",


"<img source=\"ringtoolicon\"><b>Ringe and Molekle in XDrawChem's Bibliothek</b>"
"<p>XDrawChem kommt standardmig mit den 20 natrlich vorkommenden Aminosuren "
"sowie den Nukleinsuren Adenin, Guanin, Cytosin, Thymin und Uracil."
"<p><b>Hinzufgen von Moleklen</b><br>"
"Um ein Molekl zum Ringdialog hinzuzufgen mu man es nur im CML Format im "
"RINGDIR Verzeichnis ablegen (siehe INSTALL.txt). Das Molekl erscheint dann "
"unter dem Namen, unter dem es abgespeichert wurde. Speichert man zum Beispiel "
"Methyltertbutylether als 'mtbe.cml' ab, so erscheint es in der Moleklliste unter "
"'mtbe', wenn diese da nchste mal geffnet wird."
"<p><b>Die Favoritenliste</b><br>"
"Die Favoritenliste erscheint wenn man den Ringeknopf auf der linken Werkzeugleiste circa eine halbe Sekunde lang gedrckt hlt. "
"Um Molekle zu dieser Liste hinzuzufgen mu man sie wie oben einfach im RINGDIR Verzeichnis abspeichern (siehe INSTALL.txt). "
"Nun mu man zustzlich noch ein Bild des Molekls im PNG Format unter gleichem Namen in das RINGDIR Verzeichnis hineinkopieren. "
"Zum Beispiel kann man Aceton hinzufgen indem man die CML Datei 'aceton.cml' sowie die PNG Datei 'aceton.png' in das RINGDIR "
"Verzeichnis kopiert. XDrawChem hat von Haus aus Cyclopentan, Imidazol, Cyclohexan und Benzol in der Favoritenliste. "
"Um ein Molekl aus der Favoritenliste zu entfernen mu man also lediglich dessen PNG Datei lschen."

};

// Show the manual.  Called by Help/Manual or pressing F1.
void ApplicationWindow::Manual()
{
  XManual *m = new XManual;
  m->show();
}

// Manual dialog box.  Start at page 1.  Pages defined above in manpages[]
XManual::XManual(QWidget *parent, const char *name) :
  QDialog(parent, name)
{
  resize(400,450);
  setCaption("XDrawChem Handbuch");
  qvb = new QVBox(this, "Manual dialog box");
  qvb->setMinimumSize(400,450);
  qvb->setMargin(3);

  pagelist = new QComboBox( false, qvb );
  pagelist->insertItem("Titelseite");
  pagelist->insertItem("bersicht");
  pagelist->insertItem("Die Werkzeugleiste des Dateimens");
  pagelist->insertItem("Die Werkzeugleiste frs Zeichnen");
  pagelist->insertItem("Text");
  pagelist->insertItem("Auswhlen und Bearbeiten");
  pagelist->insertItem("Formatierung");
  pagelist->insertItem("Werkzeuge");
  pagelist->insertItem("Internetsuche");
  pagelist->insertItem("Verfgbare Ringe und Molekle");
  connect( pagelist, SIGNAL( activated(int) ), this, SLOT( gotoPage(int) ) );

  pages = new QTextView( qvb );
  pages->setText( manpages[0] );
  QBrush paper( QColor(255,255,255) );
  pages->setPaper( paper );

  QHBox *buttons = new QHBox( qvb );
  buttons->setMargin( 3 );

  bClose = new QPushButton( "&Schlieen", buttons );
  QWidget *w = new QWidget( buttons );
  w->setMaximumHeight( bClose->sizeHint().height() );
  bPrev = new QPushButton( "<< &Zurck", buttons );
  bLabel = new QLabel( "Seite 1", buttons );
	bLabel->setAlignment(AlignCenter);
  bNext = new QPushButton( "&Weiter >>", buttons );
  buttons->setMaximumHeight( bNext->sizeHint().height() + 10 );

  bPrev->setEnabled( FALSE );

  connect( bClose, SIGNAL( clicked() ), this, SLOT( close() ) );
  connect( bPrev, SIGNAL( clicked() ), this, SLOT( prevPage() ) );
  connect( bNext, SIGNAL( clicked() ), this, SLOT( nextPage() ) );

  pagenum = 0;
  lastpage = 9;
}

// Turn to previous manual page.
void XManual::prevPage()
{
	if (pagenum == 0) return;
	pagenum--;
	pages->setText(manpages[pagenum]);
	if (pagenum == 0) bPrev->setEnabled(false);
	bNext->setEnabled(true);

	QString q;
	q.setNum(pagenum + 1);
	bLabel->setText( QString("Seite ") + q );

	pagelist->setCurrentItem(pagenum);
}

// Turn to next manual page.
void XManual::nextPage()
{
	if (pagenum == lastpage) return;
	pagenum++;
	pages->setText(manpages[pagenum]);
	if (pagenum == lastpage) bNext->setEnabled(false);
	bPrev->setEnabled(true);

	QString q;
	q.setNum(pagenum + 1);
	bLabel->setText( QString("Seite ") + q );

	pagelist->setCurrentItem(pagenum);
}

// Goto a specific page by number.
// NOTE: gotoPage assumes first page is 0.
void XManual::gotoPage(int thispage)
{
	if (thispage > lastpage) return;
	pagenum = thispage;
	bNext->setEnabled(true);
	bPrev->setEnabled(true);
	if (pagenum == 0) bPrev->setEnabled(false);
	if (pagenum == lastpage) bNext->setEnabled(false);
	pages->setText( manpages[thispage] );
	QString q;
	q.setNum(thispage+1);
	bLabel->setText( QString("Seite ") + q );
}

// Handle resize.  Propagates the event to QVBox* qvb, which handles
// resize for its children.
void XManual::resizeEvent(QResizeEvent *re)
{
	qvb->resize( re->size() );
}
